---------------------
-- Library calling --
---------------------
--Call the ACE Libraries
MBPNV = LibStub("AceGUI-3.0")
--local AceGUI = LibStub("AceGUI-3.0")
MBPNVC = LibStub("AceConsole-3.0")
LibStub("AceEvent-3.0"):Embed(MBPNV)
LibStub("AceTimer-3.0"):Embed(MBPNV)



-------------------------------------------------------------------------------
-------------------
-- clear filters --
-------------------


function ClearFilters()
   p = C_PetJournal
   p.AddAllPetSourcesFilter(true)
   p.AddAllPetTypesFilter(true)
   p.ClearSearchFilter(true)
   
end


-------------------------------------------------------------------------------
----------------------
-- local definitons --
----------------------
continentID, zoneID = {},{}--continentID, zoneID
Zones = {{}}
ZoneNames = {}
ZoneTree = {{{{}}}}--tree
rarityColor = { 
   [0] = "|cffff0000",
   [1] = "|cFF8f8f8f",
   [2] = "|cFFffffff",
   [3] = "|cFF00ff00",
   [4] = "|cFF0080ff",
   [5] = "|cFF9482C9",
   [6] = "|cffff8000",
   [7] = "|cFFe6cc80",
   ["red"] = "|cffff0000",
   ["grey"] = "|cFF8f8f8f",
   ["white"] = "|cFFffffff",
   ["green"] = "|cFF00ff00",
   ["blue"] = "|cFF0080ff",
   ["purple"] = "|cFF9482C9",
   ["orange"] = "|cffff8000",
   ["gold"] = "|cFFe6cc80",
}
color = {
   ["red"] = "|cffff0000",
   ["grey"] = "|cFF8f8f8f",
   ["white"] = "|cFFffffff",
   ["green"] = "|cFF00ff00",
   ["blue"] = "|cFF0080ff",
   ["purple"] = "|cFF9482C9",
   ["orange"] = "|cffff8000",
   ["gold"] = "|cFFe6cc80",
}

creature = {
   [1] = "Humanoid",
   [2] = "Dragonkin",
   [3] = "Flying",
   [4] = "Undead",
   [5] = "Critter",
   [6] = "Magic",
   [7] = "Elemental",
   [8] = "Beast",
   [9] = "Aquatic",
   [10]= "Mechanical",
}
weakness = {
   [2] = "Humanoid",
   [6] = "Dragonkin",
   [9] = "Flying",
   [1] = "Undead",
   [4] = "Critter",
   [3] = "Magic",
   [10] = "Elemental",
   [5] = "Beast",
   [7] = "Aquatic",
   [8] = "Mechanical",
   
   ["Humanoid"] = 2,
   ["Dragonkin"] = 6,
   ["Flying"] = 9,
   ["Undead"] = 1,
   ["Critter"] = 4,
   ["Magic"] = 3,
   ["Elemental"] = 10,
   ["Beast"] = 5,
   ["Aquatic"] = 7,
   ["Mechanical"] = 8,
}
strength = {
   [8] = "Humanoid",
   [4] = "Dragonkin",
   [2] = "Flying",
   [9] = "Undead",
   [1] = "Critter",
   [10] = "Magic",
   [5] = "Elemental",
   [3] = "Beast",
   [6] = "Aquatic",
   [7] = "Mechanical",
   
   ["Humanoid"] = 8,
   ["Dragonkin"] = 4,
   ["Flying"] = 2,
   ["Undead"] = 9,
   ["Critter"] = 1,
   ["Magic"] = 10,
   ["Elemental"] = 5,
   ["Beast"] = 3,
   ["Aquatic"] = 6,
   ["Mechanical"] = 7,
}

---------------------
-- Set Zone Levels --
---------------------


-------------------------------------------------------------------------------
--------------------------
-- Conversion functions --
--------------------------
-- convert continent ID to continent name
function GetContinentByID(ID)
   continents = {GetMapContinents()}
   return continents[ID]
end
-- convert continent ID and zone ID to zone name
function GetZoneByID(continent, zone)
   zones = {GetMapZones(continent)}
   return zones[zone]
end
-------------------------------------------------------------------------------
---------------------------------
-- Code for searching for pets --
---------------------------------
function GetPetInfoByID(id)
   local speciesID, customName, level, xp, maxXp, displayID, name, icon, petType, creatureID, sourceText, description, isWild, canBattle,
   tradable, unique = C_PetJournal.GetPetInfoByPetID(id)
   local health, maxHealth, attack, speed, rarity = p.GetPetStats(id)
   sourceText=string.gsub(sourceText,"Valley of Four Winds","Valley of the Four Winds")
   local link = ""
   if id > 0 then 
      link = p.GetBattlePetLink(id) 
   end
   if customName == nil then customName = name end
   return name, customName, level, xp, maxXp, sourceText, description, health, maxHealth, rarity, link
end
function PetSearch(search)
   
   ClearFilters()
   x={};
   local text = ""
   labels = {}
   local count = 1
   --scroll:ReleaseChildren()
   p = C_PetJournal;
   local n = "|n"
   for i=1,p.GetNumPets(false) do 
      local label = MBPNsearch:Create("InteractiveLabel")
      label:SetFullWidth(true)
      id,_,_,_,l,_,_,nm,_,_,_,d=p.GetPetInfoByIndex(i);
      if string.find(strlower(nm), strlower(editBoxText)) and not x[nm] then 
         if id>0 then 
            name, customName, level, xp, maxXp, sourceText, description, health, maxHealth, rarity = GetPetInfoByID(id)
            cName = ""
            sourceText=string.gsub(sourceText,"Valley of Four Winds","Valley of the Four Winds")
            if name ~= customName then cName = " ("..customName..")" end
            label:SetText(p.GetBattlePetLink(id)..cName.." (L"..l..")"..n..sourceText..n..d..n..n)
         else 
            label:SetText(nm..n..d..n..n)
            x[nm]=1;
         end 
         labels[count] = label
         
         count = count + 1
      end 
   end
   return labels
end

function GetZoneLevelByName(zoneName)
   local zn = ZoneNames[zoneName]
   if zn == nil then return nil
   else
      return zn[1],zn[2]
   end
end

local function z(zone,min,max)
   local counter = 1
   if # Zones ~= nil then counter = # Zones + 1 end
   Zones[counter] = {zone,min,max}
   ZoneNames[zone] = {min,max}
end

local function SetZoneLevels()
   --Kalimdor
   z("Azuremyst Isle",1,2)
   z("Ammen Vale",1,2)
   z("Camp Narache",1,2)
   z("Valley of Trials",1,2)
   z("Echo Isles",1,2)
   z("Durotar",1,2)
   z("Shadowglen",1,2)
   z("Teldrassil",1,2)
   z("Darnassus",1,2)
   z("The Exodar",1,2)
   z("Mulgore",1,2)
   z("Thunder Bluff",1,2)
   z("Orgrimmar",1,2)
   z("Northern Barrens",3,4)
   z("Ashenvale",4,5)
   z("Azshara",3,5)
   z("Bloodmyst Isle",3,5)
   z("Darkshore",3,5)
   z("Stonetalon Mountains",5,6)
   z("Desolace",7,8)
   z("Southern Barrens",9,10)
   z("Feralas",11,12)
   z("Dustwallow Marsh",12,13)
   z("Tanaris",13,14)
   z("Thousand Needles",13,14)
   z("Felwood",14,15)
   z("Moonglade",15,16)
   z("Un'Goro Crater",15,16)
   z("Ahn'Qiraj: The Fallen Kingdom",16,17)
   z("Silithus",16,17)
   z("Winterspring",17,18)
   z("Mount Hyjal",22,23)
   z("Uldum",23,24)
   --Eastern Kingdoms
   z("Dun Morogh",1,2)
   z("New Tinkertown",1,2)
   z("Sunstrider Isle",1,2)
   z("Deathknell",1,2)
   z("Ruins of Gilneas",1,2)
   z("Ruins of Gilneas City",1,2)
   z("Elwynn Forest",1,2)
   z("Eversong Woods",1,2)
   z("Tirisfal Glades",1,2)
   z("Ironforge",1,2)
   z("Silvermoon City",1,2)
   z("Stormwind City",1,2)
   z("Undercity",1,2)
   z("Westfall",3,4)
   z("Ghostlands",3,5)
   z("Loch Modan",3,5)
   z("Redridge Mountains",4,5)
   z("Northshire",4,5)
   z("Silverpine Forest",3,5)
   z("Duskwood",5,6)
   z("Hillsbrad Foothills",6,7)
   z("Wetlands",6,7)
   z("Arathi Highlands",7,8)
   z("Northern Stranglethorn",7,8)
   z("Stranglethorn Vale",7,8)
   z("Coldridge Valley",7,8)
   z("The Cape of Stranglethorn",9,10)
   z("Western Plaguelands",10,11)
   z("The Hinterlands",11,12)
   z("Eastern Plaguelands",12,13)
   z("Badlands",13,14)
   z("Searing Gorge",13,14)
   z("Swamp of Sorrows",14,15)
   z("Burning Steppes",15,16)
   z("Blasted Lands",16,17)
   z("Deadwind Pass",17,18)
   z("Twilight Highlands",23,24)
   z("Isle of Quel'Danas",23,24)
   z("Abyssal Depths",23,24)
   z("Shimmering Expanse",23,24)
   z("Tol Barad",23,24)
   z("Tol Barad Peninsula",23,24)
   z("Vashj'ir",23,24)
   z("Kelp'thar Forest",23,24)
   --The Maelstrom
   z("Deepholm",22,23)
   z("Kezan",1,2)
   z("The Lost Isles",1,2)
   z("The Maelstrom",1,2)
   --Outland
   z("Hellfire Peninsula",17,18)
   z("Nagrand",18,19)
   z("Terokkar",18,19)
   z("Zangarmarsh",18,19)
   z("Shattrath",18,19)
   z("Blade's Edge Mountains",18,19)
   z("Netherstorm",20,21)
   z("Shadowmoon Valley",20,21)
   --Northrend
   z("Borean Tundra",20,21)
   z("Hrothgar's Landing",20,21)
   z("Grizzly Hills",21,22)
   z("Howling Fjord",20,21)
   z("Sholazar Basin",21,22)
   z("Crystalsong Forest",22,23)
   z("Dragonblight",22,23)
   z("Icecrown",22,23)
   z("The Storm Peaks",22,23)
   z("Wintergrasp",22,23)
   z("Dalaran",22,23)
   z("Zul'Drak",22,23)
   --Pandaria
   z("Dread Wastes",24,24)
   z("Krasarang Wilds",23,24)
   z("Kun-Lai Summit",23,24)
   z("The Jade Forest",23,24)
   z("The Veiled Stair",23,24)
   z("Townlong Steppes",24,24)
   z("Vale of Eternal Blossoms",24,24)
   z("Shrine of Seven Stars",24,24)
   z("Shrine of Two Moons",24,24)
   z("Valley of the Four Winds",23,24)
end

function SearchZoneForPets(zone,x)
   local pets = {{}}
   local count = 0
   local p = C_PetJournal
   local numPets = p.GetNumPets(false)
   --MyBattlePetNotifierConsole:Print(numPets)
   for i=1,numPets do
      local petID, speciesID, isOwned, customName, level, favorite, isRevoked, name, icon, petType, creatureID, sourceText, description, isWildPet, canBattle = p.GetPetInfoByIndex(i)
      if petID ~= nil then
         local health, maxHealth, attack, speed, rarity = p.GetPetStats(petID)
         local link = ""
         petID = tonumber(petID)
         sourceText=string.gsub(sourceText,"Valley of Four Winds","Valley of the Four Winds")  -- Blizzard had a typo on some pets.  this corrects that typo
         if petID then link = p.GetBattlePetLink(petID) end
         if link == nil then link = "" end
         if customName == nil then
            customName = name
         end
         if rarity == nil and (level == nil or level == 0) then
            rarity = 0
         end
         if rarity == nil and level ~= nil then
            rarity = 0
         end
         if level == nil then level = 0 end
         if string.find(strlower(zone), "n-lai summit") then zone = "n-lai summit" end -- an oddity with Kun'Lai Summit....for some reason, the ' is a problem.  meh.
         
         if string.find(strlower(sourceText),strlower(zone)) then
            count = count + 1
            pets[count] = {
               ["name"] = name,
               ["customName"] = customName,
               ["level"] = level,
               ["icon"] = icon,
               ["petID"] = petID,
               ["sourceText"] = sourceText,
               ["description"] = description,
               ["index"] = i,
               ["speciesID"] = speciesID,
               ["health"] = health,
               ["maxHealth"] = maxHealth,
               ["rarity"] = rarity,
               ["link"] = link
            }
         end
		 else
			--local health, maxHealth, attack, speed, rarity = p.GetPetStats(petID)
			local link = ""
			petID = 0
			sourceText=string.gsub(sourceText,"Valley of Four Winds","Valley of the Four Winds")  -- Blizzard had a typo on some pets.  this corrects that typo
			--if petID then link = p.GetBattlePetLink(petID) end
			if link == nil then link = "" end
			if customName == nil then
				customName = name
			end
			if rarity == nil and (level == nil or level == 0) then
				rarity = 0
			end
			if rarity == nil and level ~= nil then
				rarity = 0
			end
			if level == nil then level = 0 end
			if string.find(strlower(zone), "n-lai summit") then zone = "n-lai summit" end -- an oddity with Kun'Lai Summit....for some reason, the ' is a problem.  meh.
         
			if string.find(strlower(sourceText),strlower(zone)) then
				count = count + 1
				pets[count] = {
				["name"] = name,
				["customName"] = customName,
				["level"] = level,
				["icon"] = icon,
				["petID"] = petID,
				["sourceText"] = sourceText,
				["description"] = description,
				["index"] = i,
				["speciesID"] = speciesID,
				["health"] = 0,
				["maxHealth"] = 0,
				["rarity"] = 0,
				["link"] = link
				}
		    end
	    end
    end
   --pets returned as {name,customName,level,icon,petID,SourceText,...    }
   if x then 
      --print(pets,# pets)
      z = pets[1]
      --print(pets[1]["name"])
      --print(# z,z[1])
   end
   return pets
end

local function BuildTree()
   local tree = {{{{}}}}
   local continents = {GetMapContinents()}
   for i=1,(# continents)/2 do
      local child = {{}}
      local zones = {GetMapZones(i)}
      for j=1,(# zones)/2 do
         local pets={{}}
         pets = SearchZoneForPets(zones[j * 2])
         if pets ~= nil and # pets > 0 then
            petNodes = {{}}
            z = {}
            local num = 1
            local count = 1
            local myPets = {}
            for k=1,# pets do
               local id = pets[k]["petID"]
               local name = pets[k]["name"]
               local rarity = pets[k]["rarity"]
               local level = pets[k]["level"]
               if name ~= nil then
                  if z[pets[k]["name"]] == nil then
                     z[pets[k]["name"]] = 1
                     myPets = {}
                     num = 1
                     if id ~= nil then 
                        myPets[num] = {value = id, text = rarityColor[rarity]..name.."|r L"..level}
                        petNodes[count] = {value = name, text = name}
                     else
                        petNodes[count] = {value = name, text = name}
                     end
                     count = count + 1
                  else
                     if id ~= nil then
                        num = num + 1
                        myPets[num] = {value = id, text = rarityColor[rarity]..name.."|r L"..level}
                     end
                  end
                  if myPets ~= nil and # myPets > 0 then
                     petNodes[count-1] = {value = name, text = name, children = myPets}
                  end
               end
            end
            if petNodes == nil or # petNodes <= 1 then
               child[j] = {value = zones[j*2], text = zones[j*2]}
            else
               child[j] = {value = zones[j*2], text = zones[j*2], children = petNodes}
            end
         end
      end
      if child == nil then
         tree[i] = {value =continents[i*2], text = continents[i*2]}
      else
         tree[i] = {value =continents[i*2], text = continents[i*2], children = child}
      end
   end
   ZoneTree = tree
end

SetZoneLevels()
BuildTree()
local scanning = false

function MBPNV:PET_JOURNAL_LIST_UPDATE()
   if scanning then return end
   self:ScheduleTimer("TimerFeedback",10)
   scanning = true
   BuildTree()
end

function MBPNV:TimerFeedback()
   --print("scanning...")
   scanning = false
end

MBPNV:RegisterEvent("PET_JOURNAL_LIST_UPDATE")